Post

Leetcode 133. Clone Graph

Explanation for Leetcode 133 - Clone Graph, and its solution in Python.

Problem

Leetcode 133. Clone Graph

Example:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
Input: adjList = [[2,4],[1,3],[2,4],[1,3]]
Output: [[2,4],[1,3],[2,4],[1,3]]
Explanation: There are 4 nodes in the graph.
1st node (val = 1)'s neighbors are 2nd node (val = 2) and 4th node (val = 4).
2nd node (val = 2)'s neighbors are 1st node (val = 1) and 3rd node (val = 3).
3rd node (val = 3)'s neighbors are 2nd node (val = 2) and 4th node (val = 4).
4th node (val = 4)'s neighbors are 1st node (val = 1) and 3rd node (val = 3).

Input: adjList = [[]]
Output: [[]]
Explanation: Note that the input contains one empty list. The graph consists of only one node with val = 1 and it does not have any neighbors.

Input: adjList = []
Output: []
Explanation: This an empty graph, it does not have any nodes.

Approach

We can use DFS to find all the neighbors, and we can use visisted hash map to track what’s been visited since all node.val are unique

Here is the Python code for the solution:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
class Solution:
    def cloneGraph(self, node: Optional['Node']) -> Optional['Node']:
        visited = {}

        def dfs(node):
            if node in visited:
                return visited[node]
            
            copy = Node(node.val)
            visited[node] = copy

            for n in node.neighbors:
                copy.neighbors.append(dfs(n))
            
            return copy
        
        return dfs(node) if node else None    

Time Complexity and Space Complexity

Time Complexity: $O(V+E)$

Space Complexity: $O(V)$

This post is licensed under CC BY 4.0 by the author.